/* Se citeste n, apoi numele si media a n copii
    Sa se afiseze copiii in ordine descrescatoare dupa medie
    si la aceeasi medie, lexicografic dupa nume
*/
#include <fstream>

struct Elev {
    std::string nume;
    double media;
};


void CitesteElevii(Elev e[], int& n);
void SorteazaElevii(Elev e[], int n);
void AfiseazaElevii(Elev e[], int n);

int main()
{
    Elev e[1000];
    int n;

    CitesteElevii(e, n);
    AfiseazaElevii(e, n);
    SorteazaElevii(e, n);
    AfiseazaElevii(e, n);

    return 0;
}

void CitesteElevii(Elev e[], int& n)
{
    std::ifstream fin("elevi.in");

    fin >> n;
    for (int i = 0; i < n; ++i)
        fin >> e[i].nume >> e[i].media;
    fin.close();
}

void SorteazaElevii(Elev e[], int n)
{
    Elev aux;
    for (int i = 0; i < n - 1; ++i)
        for (int j = i + 1; j < n; ++j)
            if (e[i].media < e[j].media ||
                (e[i].media == e[j].media && e[i].nume > e[j].nume))
            {
                aux = e[i];
                e[i] = e[j];
                e[j] = aux;
            }
}

void AfiseazaElevii(Elev e[], int n)
{
    std::ofstream fout("elevi.out", std::ios_base::out | std::ios_base::app);

    for (int i = 0; i < n; ++i)
        fout << e[i].nume << ' '
             << e[i].media << '\n';
    fout << "\n\n";
    fout.close();
}
